package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.List;
import java.util.Map;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.configuration.PluginConfigurationUpdate;
import org.rhq.core.domain.configuration.ResourceConfigurationUpdate;
import org.rhq.core.domain.configuration.composite.ResourceConfigurationComposite;
import org.rhq.core.domain.configuration.definition.ConfigurationDefinition;
import org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate;
import org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate;
import org.rhq.core.domain.criteria.GroupPluginConfigurationUpdateCriteria;
import org.rhq.core.domain.criteria.GroupResourceConfigurationUpdateCriteria;
import org.rhq.core.domain.criteria.PluginConfigurationUpdateCriteria;
import org.rhq.core.domain.criteria.ResourceConfigurationUpdateCriteria;
import org.rhq.core.domain.util.PageControl;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ConfigurationGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void purgePluginConfigurationUpdates( int[] configUpdateIds, boolean purgeInProgress, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void purgeResourceConfigurationUpdates( int[] configUpdateIds, boolean purgeInProgress, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void rollbackPluginConfiguration( int resourceId, int configHistoryId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void rollbackResourceConfiguration( int resourceId, int configHistoryId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getLatestResourceConfigurationUpdate( int resourceId, AsyncCallback<org.rhq.core.domain.configuration.ResourceConfigurationUpdate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getLatestPluginConfigurationUpdate( int resourceId, AsyncCallback<org.rhq.core.domain.configuration.PluginConfigurationUpdate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getPluginConfiguration( int resourceId, AsyncCallback<org.rhq.core.domain.configuration.Configuration> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getPluginConfigurationDefinition( int resourceTypeId, AsyncCallback<org.rhq.core.domain.configuration.definition.ConfigurationDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getResourceConfiguration( int resourceId, AsyncCallback<org.rhq.core.domain.configuration.Configuration> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void getResourceConfigurationDefinition( int resourceTypeId, AsyncCallback<org.rhq.core.domain.configuration.definition.ConfigurationDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findResourceConfigurationUpdates( java.lang.Integer resourceId, java.lang.Long beginDate, java.lang.Long endDate, boolean suppressOldest, org.rhq.core.domain.util.PageControl pc, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.configuration.ResourceConfigurationUpdate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void updateResourceConfiguration( int resourceId, org.rhq.core.domain.configuration.Configuration configuration, AsyncCallback<org.rhq.core.domain.configuration.ResourceConfigurationUpdate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void updatePluginConfiguration( int resourceId, org.rhq.core.domain.configuration.Configuration configuration, AsyncCallback<org.rhq.core.domain.configuration.PluginConfigurationUpdate> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findResourceConfigurationUpdatesByCriteria( org.rhq.core.domain.criteria.ResourceConfigurationUpdateCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.configuration.ResourceConfigurationUpdate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findPluginConfigurationUpdatesByCriteria( org.rhq.core.domain.criteria.PluginConfigurationUpdateCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.configuration.PluginConfigurationUpdate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findGroupResourceConfigurationUpdatesByCriteria( org.rhq.core.domain.criteria.GroupResourceConfigurationUpdateCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.configuration.group.GroupResourceConfigurationUpdate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findGroupPluginConfigurationUpdatesByCriteria( org.rhq.core.domain.criteria.GroupPluginConfigurationUpdateCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.configuration.group.GroupPluginConfigurationUpdate>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findResourceConfigurationsForGroup( int groupId, AsyncCallback<java.util.Map<java.lang.Integer,org.rhq.core.domain.configuration.Configuration>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findPluginConfigurationsForGroup( int groupId, AsyncCallback<java.util.Map<java.lang.Integer,org.rhq.core.domain.configuration.Configuration>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findResourceConfigurationsForGroupUpdate( int groupUpdateId, AsyncCallback<java.util.Map<java.lang.Integer,org.rhq.core.domain.configuration.Configuration>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void findPluginConfigurationsForGroupUpdate( int groupUpdateId, AsyncCallback<java.util.Map<java.lang.Integer,org.rhq.core.domain.configuration.Configuration>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void updateResourceConfigurationsForGroup( int groupId, java.util.List<org.rhq.core.domain.configuration.composite.ResourceConfigurationComposite> resourceConfigurations, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void updatePluginConfigurationsForGroup( int groupId, java.util.List<org.rhq.core.domain.configuration.composite.ResourceConfigurationComposite> pluginConfigurations, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void deleteGroupPluginConfigurationUpdate( java.lang.Integer groupId, java.lang.Integer[] groupPluginConfigUpdateIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ConfigurationGWTService
     */
    void deleteGroupResourceConfigurationUpdate( java.lang.Integer groupId, java.lang.Integer[] groupResourceConfigUpdateIds, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ConfigurationGWTServiceAsync instance;

        public static final ConfigurationGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ConfigurationGWTServiceAsync) GWT.create( ConfigurationGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ConfigurationGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
