package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.List;
import org.rhq.core.domain.content.Architecture;
import org.rhq.core.domain.content.InstalledPackageHistory;
import org.rhq.core.domain.content.Package;
import org.rhq.core.domain.content.PackageType;
import org.rhq.core.domain.content.PackageVersion;
import org.rhq.core.domain.content.composite.PackageAndLatestVersionComposite;
import org.rhq.core.domain.content.composite.PackageTypeAndVersionFormatComposite;
import org.rhq.core.domain.criteria.InstalledPackageHistoryCriteria;
import org.rhq.core.domain.criteria.PackageCriteria;
import org.rhq.core.domain.criteria.PackageVersionCriteria;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ContentGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void deletePackageVersion( int packageVersionId, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void findPackageVersionsByCriteria( org.rhq.core.domain.criteria.PackageVersionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.content.PackageVersion>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void findPackagesByCriteria( org.rhq.core.domain.criteria.PackageCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.content.Package>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void findPackagesWithLatestVersion( org.rhq.core.domain.criteria.PackageCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.content.composite.PackageAndLatestVersionComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void getInstalledPackageHistoryForResource( int resourceId, int count, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.content.InstalledPackageHistory>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void findInstalledPackageHistoryByCriteria( org.rhq.core.domain.criteria.InstalledPackageHistoryCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.content.InstalledPackageHistory>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void getArchitectures( AsyncCallback<java.util.List<org.rhq.core.domain.content.Architecture>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void getResourceCreationPackageType( int resourceTypeId, AsyncCallback<org.rhq.core.domain.content.PackageType> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ContentGWTService
     */
    void findPackageType( java.lang.Integer resourceTypeId, java.lang.String packageTypeName, AsyncCallback<org.rhq.core.domain.content.composite.PackageTypeAndVersionFormatComposite> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ContentGWTServiceAsync instance;

        public static final ContentGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ContentGWTServiceAsync) GWT.create( ContentGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ContentGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
