package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.criteria.DashboardCriteria;
import org.rhq.core.domain.dashboard.Dashboard;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface DashboardGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DashboardGWTService
     */
    void findDashboardsByCriteria( org.rhq.core.domain.criteria.DashboardCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.dashboard.Dashboard>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DashboardGWTService
     */
    void storeDashboard( org.rhq.core.domain.dashboard.Dashboard dashboard, AsyncCallback<org.rhq.core.domain.dashboard.Dashboard> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.DashboardGWTService
     */
    void removeDashboard( int dashboardId, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static DashboardGWTServiceAsync instance;

        public static final DashboardGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (DashboardGWTServiceAsync) GWT.create( DashboardGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "DashboardGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
